package com.qmth.cqb.paper.service;


import com.qmth.cqb.paper.model.PaperStructSearchInfo;
import com.qmth.cqb.utils.BeanCopierUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.data.domain.ExampleMatcher;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;

import com.qmth.cqb.paper.dao.PaperStructRepo;
import com.qmth.cqb.paper.model.PaperStruct;

import java.util.List;
/**
 * Created by songyue on 16/12/28.
 */
@Service
public class PaperStructService {
	
	@Autowired
    PaperStructRepo paperStructRepo;


    /**
     * 获取所有试卷结构
     * @param searchInfo
     * @param curPage
     * @param pageSize
     * @return
     */
    public Page<PaperStruct> getPaperStructs(PaperStructSearchInfo searchInfo,
                                             int curPage,
                                             int pageSize){
        formatSearchInfo(searchInfo);
        PaperStruct paperStruct = BeanCopierUtil.copyProperties(searchInfo,PaperStruct.class);
        formatPaperStruct(paperStruct);
        ExampleMatcher matcher = ExampleMatcher.matching().
                withStringMatcher(ExampleMatcher.StringMatcher.CONTAINING).withIgnoreNullValues();
        return paperStructRepo.findAll(Example.of(paperStruct,matcher),
                new PageRequest(curPage - 1,pageSize));
    }

    public void formatSearchInfo(PaperStructSearchInfo searchInfo){
        if(StringUtils.isEmpty(searchInfo.getName())){
            searchInfo.setName(null);
        }
        if(StringUtils.isEmpty(searchInfo.getCreator())){
            searchInfo.setCreator(null);
        }
    }

    public void formatPaperStruct(PaperStruct paperStruct){
        paperStruct.setCreateTime(null);
    }


}
